Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections
Class CursorableLinkedList

    java.lang.Object
      |
      +--org.apache.commons.collections.CursorableLinkedList

All Implemented Interfaces:
  Collection, List, Serializable

Deprecated. Use new version in list subpackage, which has been rewritten and now returns the cursor from the listIterator method. Will be removed in v4.0

public class CursorableLinkedList
extends Object
implements List, Serializable

A doubly-linked list implementation of the `List` interface, supporting a `ListIterator` that allows concurrent modifications to the underlying list.

Implements all of the optional `List` operations, the stack/queue/dequeue operations available in `LinkedList` and supports a `ListIterator` that allows concurrent modifications to the underlying list (see `cursor()`).

Note that this implementation is not synchronized.

Since:
  Commons Collections 1.0
Version:
  $Revision: 1.23 $ $Date: 2004/02/18 01:15:42 $
Author:
  Rodney Waldhoff, Janek Bogucki, Simon Kitching
See Also:
  `LinkedList`, Serialized Form

Nested Class Summary
`class` | `CursorableLinkedList.Cursor` Deprecated.

Field Summary
`protected List` | `_cursors` Deprecated. A list of the currently `CursorableLinkedList.Cursor`s currently open in this list.
`protected org.apache.commons.collections.CursorableLinkedList.Listable` | `_head` Deprecated. A sentry node.
`protected int` | `_modCount` Deprecated. Tracks the number of structural modifications to me.
`protected int` | `_size` Deprecated. The number of elements in me.

Constructor Summary
`CursorableLinkedList()` Deprecated.

Method Summary
`void` | `add(int index, Object element)` Deprecated. Inserts the specified element at the specified position in this list.
`boolean` | `add(Object o)` Deprecated. Appends the specified element to the end of this list.
`boolean` | `addAll(Collection c)` Deprecated. Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified `Collection`'s `Iterator`.
`boolean` | `addAll(int index, Collection c)` Deprecated. Inserts all of the elements in the specified collection into this list at the specified position.
`boolean` | `addFirst(Object o)` Deprecated. Inserts the specified element at the beginning of this list.
`boolean` | `addLast(Object o)` Deprecated. Inserts the specified element at the end of this list.
`protected void` | `broadcastListableChanged(org.apache.commons.collections.CursorableLinkedList.Listable elt)` Deprecated. Informs all of my registered cursors that the specified element was changed.
`protected void` | `broadcastListableInserted(org.apache.commons.collections.CursorableLinkedList.Listable elt)` Deprecated. Informs all of my registered cursors that the specified element was just added to my list.
`protected void` | `broadcastListableRemoved(org.apache.commons.collections.CursorableLinkedList.Listable elt)` Deprecated. Informs all of my registered cursors that the specified element was just removed from my list.
`void` | `clear()` Deprecated. Removes all of the elements from this list.
`boolean` | `contains(Object o)` Deprecated. Returns `true` if this list contains the specified element.
`boolean` | `containsAll(Collection c)` Deprecated. Returns `true` if this list contains all of the elements of the specified collection.
`CursorableLinkedList.Cursor` | `cursor()` Deprecated. Returns a `ListIterator` for iterating through the elements of this list.
`CursorableLinkedList.Cursor` | `cursor(int i)` Deprecated. Returns a `ListIterator` for iterating through the elements of this list, initialized such that `ListIterator.next()` will return the element at the specified index (if any) and `ListIterator.previous()` will return the element immediately preceding it (if any).
`boolean` | `equals(Object o)` Deprecated. Compares the specified object with this list for equality.
`Object` | `get(int index)` Deprecated. Returns the element at the specified position in this list.
`Object` | `getFirst()` Deprecated. Returns the element at the beginning of this list.
`Object` | `getLast()` Deprecated. Returns the element at the end of this list.
`protected org.apache.commons.collections.CursorableLinkedList.Listable` | `getListableAt(int index)` Deprecated. Returns the `CursorableLinkedList.Listable` at the specified index.
`int` | `hashCode()` Deprecated. Returns the hash code value for this list.
`int` | `indexOf(Object o)` Deprecated. Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.
`protected org.apache.commons.collections.CursorableLinkedList.Listable` | `insertListable(org.apache.commons.collections.CursorableLinkedList.Listable before, org.apache.commons.collections.CursorableLinkedList.Listable after, Object value)` Deprecated. Inserts a new value into my list, after the specified before element, and before the specified after element
`protected void` | `invalidateCursors()` Deprecated. Informs all of my registered cursors that they are now invalid.
`boolean` | `isEmpty()` Deprecated. Returns `true` if this list contains no elements.
`Iterator` | `iterator()` Deprecated. Returns a fail-fast iterator.
`int` | `lastIndexOf(Object o)` Deprecated. Returns the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element.
`ListIterator` | `listIterator()` Deprecated. Returns a fail-fast ListIterator.
`ListIterator` | `listIterator(int index)` Deprecated. Returns a fail-fast ListIterator.
`protected void` | `registerCursor(CursorableLinkedList.Cursor cur)` Deprecated. Registers a `CursorableLinkedList.Cursor` to be notified of changes to this list.
`Object` | `remove(int index)` Deprecated. Removes the element at the specified position in this list (optional operation).
`boolean` | `remove(Object o)` Deprecated. Removes the first occurrence in this list of the specified element.
`boolean` | `removeAll(Collection c)` Deprecated. Removes from this list all the elements that are contained in the specified collection.
`Object` | `removeFirst()` Deprecated. Removes the first element of this list, if any.
`Object` | `removeLast()` Deprecated. Removes the last element of this list, if any.
`protected void` | `removeListable(org.apache.commons.collections.CursorableLinkedList.Listable elt)` Deprecated. Removes the given `CursorableLinkedList.Listable` from my list.
`boolean` | `retainAll(Collection c)` Deprecated. Retains only the elements in this list that are contained in the specified collection.
`Object` | `set(int index, Object element)` Deprecated. Replaces the element at the specified position in this list with the specified element.
`int` | `size()` Deprecated. Returns the number of elements in this list.
`List` | `subList(int i, int j)` Deprecated. Returns a fail-fast sublist.
`Object[]` | `toArray()` Deprecated. Returns an array containing all of the elements in this list in proper sequence.
`Object[]` | `toArray(Object[] a)` Deprecated. Returns an array containing all of the elements in this list in proper sequence; the runtime type of the returned array is that of the specified array.
`String` | `toString()` Deprecated. Returns a `String` representation of this list, suitable for debugging.
`protected void` | `unregisterCursor(CursorableLinkedList.Cursor cur)` Deprecated. Removes a `CursorableLinkedList.Cursor` from the set of cursors to be notified of changes to this list.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### _size

    protected transient int _size

  Deprecated.
  The number of elements in me.

### _head

    protected transient org.apache.commons.collections.CursorableLinkedList.Listable _head

  Deprecated.
  A sentry node.

  `_head.next()` points to the first element in the list, `_head.prev()` to the last. Note that it is possible for `_head.next().prev()` and `_head.prev().next()` to be non-null, as when I am a sublist for some larger list. Use `== _head.next()` and `== _head.prev()` to determine if a given `CursorableLinkedList.Listable` is the first or last element in the list.

### _modCount

    protected transient int _modCount

  Deprecated.
  Tracks the number of structural modifications to me.

### _cursors

    protected transient List _cursors

  Deprecated.
  A list of the currently `CursorableLinkedList.Cursor`s currently open in this list.

Constructor Detail

### CursorableLinkedList

    public CursorableLinkedList()

  Deprecated.

Method Detail

### add

    public boolean add(Object o)

  Deprecated.
  Appends the specified element to the end of this list.

  Specified by:
    `add` in interface `List`
  Parameters:
    `o` - element to be appended to this list.
  Returns:
    `true`

### add

    public void add(int index,
                    Object element)

  Deprecated.
  Inserts the specified element at the specified position in this list. Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).

  Specified by:
    `add` in interface `List`
  Parameters:
    `index` - index at which the specified element is to be inserted.
    `element` - element to be inserted.
  Throws:
    `ClassCastException` - if the class of the specified element prevents it from being added to this list.
    `IllegalArgumentException` - if some aspect of the specified element prevents it from being added to this list.
    `IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).

### addAll

    public boolean addAll(Collection c)

  Deprecated.
  Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified `Collection`'s `Iterator`. The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)

  Specified by:
    `addAll` in interface `List`
  Parameters:
    `c` - collection whose elements are to be added to this list.
  Returns:
    `true` if this list changed as a result of the call.
  Throws:
    `ClassCastException` - if the class of an element in the specified collection prevents it from being added to this list.
    `IllegalArgumentException` - if some aspect of an element in the specified collection prevents it from being added to this list.

### addAll

    public boolean addAll(int index,
                          Collection c)

  Deprecated.
  Inserts all of the elements in the specified collection into this list at the specified position. Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in this list in the order that they are returned by the specified `Collection`'s `Iterator`. The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)

  Specified by:
    `addAll` in interface `List`
  Parameters:
    `index` - index at which to insert first element from the specified collection.
    `c` - elements to be inserted into this list.
  Returns:
    `true` if this list changed as a result of the call.
  Throws:
    `ClassCastException` - if the class of one of elements of the specified collection prevents it from being added to this list.
    `IllegalArgumentException` - if some aspect of one of elements of the specified collection prevents it from being added to this list.
    `IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).

### addFirst

    public boolean addFirst(Object o)

  Deprecated.
  Inserts the specified element at the beginning of this list. (Equivalent to ``add(0,o)``).

  Parameters:
    `o` - element to be prepended to this list.
  Returns:
    `true`

### addLast

    public boolean addLast(Object o)

  Deprecated.
  Inserts the specified element at the end of this list. (Equivalent to `add(java.lang.Object)`).

  Parameters:
    `o` - element to be appended to this list.
  Returns:
    `true`

### clear

    public void clear()

  Deprecated.
  Removes all of the elements from this list. This list will be empty after this call returns (unless it throws an exception).

  Specified by:
    `clear` in interface `List`

### contains

    public boolean contains(Object o)

  Deprecated.
  Returns `true` if this list contains the specified element. More formally, returns `true` if and only if this list contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  Specified by:
    `contains` in interface `List`
  Parameters:
    `o` - element whose presence in this list is to be tested.
  Returns:
    `true` if this list contains the specified element.

### containsAll

    public boolean containsAll(Collection c)

  Deprecated.
  Returns `true` if this list contains all of the elements of the specified collection.

  Specified by:
    `containsAll` in interface `List`
  Parameters:
    `c` - collection to be checked for containment in this list.
  Returns:
    `true` if this list contains all of the elements of the specified collection.

### cursor

    public CursorableLinkedList.Cursor cursor()

  Deprecated.
  Returns a `ListIterator` for iterating through the elements of this list. Unlike `iterator()`, a cursor is not bothered by concurrent modifications to the underlying list.

  Specifically, when elements are added to the list before or after the cursor, the cursor simply picks them up automatically. When the "current" (i.e., last returned by `ListIterator.next()` or `ListIterator.previous()`) element of the list is removed, the cursor automatically adjusts to the change (invalidating the last returned value--i.e., it cannot be removed).

  Note that the returned `ListIterator` does not support the `ListIterator.nextIndex()` and `ListIterator.previousIndex()` methods (they throw `UnsupportedOperationException` when invoked.

  Historical Note: In previous versions of this class, the object returned from this method was required to be explicitly closed. This is no longer necessary.

  See Also:
    `cursor(int)`, `listIterator()`, `CursorableLinkedList.Cursor`

### cursor

    public CursorableLinkedList.Cursor cursor(int i)

  Deprecated.
  Returns a `ListIterator` for iterating through the elements of this list, initialized such that `ListIterator.next()` will return the element at the specified index (if any) and `ListIterator.previous()` will return the element immediately preceding it (if any). Unlike `iterator()`, a cursor is not bothered by concurrent modifications to the underlying list.

  Throws:
    `IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).
  See Also:
    `cursor()`, `listIterator(int)`, `CursorableLinkedList.Cursor`

### equals

    public boolean equals(Object o)

  Deprecated.
  Compares the specified object with this list for equality. Returns `true` if and only if the specified object is also a list, both lists have the same size, and all corresponding pairs of elements in the two lists are equal. (Two elements `e1` and `e2` are equal if `(e1==null ? e2==null : e1.equals(e2))`.) In other words, two lists are defined to be equal if they contain the same elements in the same order. This definition ensures that the equals method works properly across different implementations of the `List` interface.

  Specified by:
    `equals` in interface `List`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `o` - the object to be compared for equality with this list.
  Returns:
    `true` if the specified object is equal to this list.

### get

    public Object get(int index)

  Deprecated.
  Returns the element at the specified position in this list.

  Specified by:
    `get` in interface `List`
  Parameters:
    `index` - index of element to return.
  Returns:
    the element at the specified position in this list.
  Throws:
    `IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

### getFirst

    public Object getFirst()

  Deprecated.
  Returns the element at the beginning of this list.

### getLast

    public Object getLast()

  Deprecated.
  Returns the element at the end of this list.

### hashCode

    public int hashCode()

  Deprecated.
  Returns the hash code value for this list. The hash code of a list is defined to be the result of the following calculation:

        hashCode = 1;
        Iterator i = list.iterator();
        while (i.hasNext()) {
            Object obj = i.next();
            hashCode = 31*hashCode + (obj==null ? 0 : obj.hashCode());
        }

  This ensures that `list1.equals(list2)` implies that `list1.hashCode()==list2.hashCode()` for any two lists, `list1` and `list2`, as required by the general contract of `Object.hashCode`.

  Specified by:
    `hashCode` in interface `List`
  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hash code value for this list.
  See Also:
    `Object.hashCode()`, `Object.equals(Object)`, `equals(Object)`

### indexOf

    public int indexOf(Object o)

  Deprecated.
  Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element. More formally, returns the lowest index `i` such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  Specified by:
    `indexOf` in interface `List`
  Parameters:
    `o` - element to search for.
  Returns:
    the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.

### isEmpty

    public boolean isEmpty()

  Deprecated.
  Returns `true` if this list contains no elements.

  Specified by:
    `isEmpty` in interface `List`
  Returns:
    `true` if this list contains no elements.

### iterator

    public Iterator iterator()

  Deprecated.
  Returns a fail-fast iterator.

  Specified by:
    `iterator` in interface `List`
  See Also:
    `List.iterator()`

### lastIndexOf

    public int lastIndexOf(Object o)

  Deprecated.
  Returns the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element. More formally, returns the highest index `i` such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  Specified by:
    `lastIndexOf` in interface `List`
  Parameters:
    `o` - element to search for.
  Returns:
    the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element.

### listIterator

    public ListIterator listIterator()

  Deprecated.
  Returns a fail-fast ListIterator.

  Specified by:
    `listIterator` in interface `List`
  See Also:
    `List.listIterator()`

### listIterator

    public ListIterator listIterator(int index)

  Deprecated.
  Returns a fail-fast ListIterator.

  Specified by:
    `listIterator` in interface `List`
  See Also:
    `List.listIterator(int)`

### remove

    public boolean remove(Object o)

  Deprecated.
  Removes the first occurrence in this list of the specified element. If this list does not contain the element, it is unchanged. More formally, removes the element with the lowest index i such that `(o==null ? get(i)==null : o.equals(get(i)))` (if such an element exists).

  Specified by:
    `remove` in interface `List`
  Parameters:
    `o` - element to be removed from this list, if present.
  Returns:
    `true` if this list contained the specified element.

### remove

    public Object remove(int index)

  Deprecated.
  Removes the element at the specified position in this list (optional operation). Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the list.

  Specified by:
    `remove` in interface `List`
  Parameters:
    `index` - the index of the element to removed.
  Returns:
    the element previously at the specified position.
  Throws:
    `IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

### removeAll

    public boolean removeAll(Collection c)

  Deprecated.
  Removes from this list all the elements that are contained in the specified collection.

  Specified by:
    `removeAll` in interface `List`
  Parameters:
    `c` - collection that defines which elements will be removed from this list.
  Returns:
    `true` if this list changed as a result of the call.

### removeFirst

    public Object removeFirst()

  Deprecated.
  Removes the first element of this list, if any.

### removeLast

    public Object removeLast()

  Deprecated.
  Removes the last element of this list, if any.

### retainAll

    public boolean retainAll(Collection c)

  Deprecated.
  Retains only the elements in this list that are contained in the specified collection. In other words, removes from this list all the elements that are not contained in the specified collection.

  Specified by:
    `retainAll` in interface `List`
  Parameters:
    `c` - collection that defines which elements this set will retain.
  Returns:
    `true` if this list changed as a result of the call.

### set

    public Object set(int index,
                      Object element)

  Deprecated.
  Replaces the element at the specified position in this list with the specified element.

  Specified by:
    `set` in interface `List`
  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `ClassCastException` - if the class of the specified element prevents it from being added to this list.
    `IllegalArgumentException` - if some aspect of the specified element prevents it from being added to this list.
    `IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

### size

    public int size()

  Deprecated.
  Returns the number of elements in this list.

  Specified by:
    `size` in interface `List`
  Returns:
    the number of elements in this list.

### toArray

    public Object[] toArray()

  Deprecated.
  Returns an array containing all of the elements in this list in proper sequence. Obeys the general contract of the `Collection.toArray()` method.

  Specified by:
    `toArray` in interface `List`
  Returns:
    an array containing all of the elements in this list in proper sequence.

### toArray

    public Object[] toArray(Object[] a)

  Deprecated.
  Returns an array containing all of the elements in this list in proper sequence; the runtime type of the returned array is that of the specified array. Obeys the general contract of the `Collection.toArray()` method.

  Specified by:
    `toArray` in interface `List`
  Parameters:
    `a` - the array into which the elements of this list are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing the elements of this list.
  Throws:
    `ArrayStoreException` - if the runtime type of the specified array is not a supertype of the runtime type of every element in this list.

### toString

    public String toString()

  Deprecated.
  Returns a `String` representation of this list, suitable for debugging.

  Overrides:
    `toString` in class `Object`
  Returns:
    a `String` representation of this list, suitable for debugging.

### subList

    public List subList(int i,
                        int j)

  Deprecated.
  Returns a fail-fast sublist.

  Specified by:
    `subList` in interface `List`
  See Also:
    `List.subList(int,int)`

### insertListable

    protected org.apache.commons.collections.CursorableLinkedList.Listable insertListable(org.apache.commons.collections.CursorableLinkedList.Listable before,
                                                                                          org.apache.commons.collections.CursorableLinkedList.Listable after,
                                                                                          Object value)

  Deprecated.
  Inserts a new value into my list, after the specified before element, and before the specified after element

  Returns:
    the newly created `CursorableLinkedList.Listable`

### removeListable

    protected void removeListable(org.apache.commons.collections.CursorableLinkedList.Listable elt)

  Deprecated.
  Removes the given `CursorableLinkedList.Listable` from my list.

### getListableAt

    protected org.apache.commons.collections.CursorableLinkedList.Listable getListableAt(int index)

  Deprecated.
  Returns the `CursorableLinkedList.Listable` at the specified index.

  Throws:
    `IndexOutOfBoundsException` - if index is less than zero or greater than or equal to the size of this list.

### registerCursor

    protected void registerCursor(CursorableLinkedList.Cursor cur)

  Deprecated.
  Registers a `CursorableLinkedList.Cursor` to be notified of changes to this list.

### unregisterCursor

    protected void unregisterCursor(CursorableLinkedList.Cursor cur)

  Deprecated.
  Removes a `CursorableLinkedList.Cursor` from the set of cursors to be notified of changes to this list.

### invalidateCursors

    protected void invalidateCursors()

  Deprecated.
  Informs all of my registered cursors that they are now invalid.

### broadcastListableChanged

    protected void broadcastListableChanged(org.apache.commons.collections.CursorableLinkedList.Listable elt)

  Deprecated.
  Informs all of my registered cursors that the specified element was changed.

  See Also:
    `set(int,java.lang.Object)`

### broadcastListableRemoved

    protected void broadcastListableRemoved(org.apache.commons.collections.CursorableLinkedList.Listable elt)

  Deprecated.
  Informs all of my registered cursors that the specified element was just removed from my list.

### broadcastListableInserted

    protected void broadcastListableInserted(org.apache.commons.collections.CursorableLinkedList.Listable elt)

  Deprecated.
  Informs all of my registered cursors that the specified element was just added to my list.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.